# MagnetType -- Elettra 2.0 fork

Tango class to ease control of all Elettra 2.0  main magnets of one specific type
(all quadrupoles, all sextupoles or all octupoles)

## Elettra 2.0 fork

The class is a fork from the original ESRF implementation. Reasons for forking:
 1) Elettra 2.0 has some differences in the combined magnets composition (set of multipoles) and in the excitation schemes for combined magnets.
 2) We must use our local gitlab repository in order to use the INAU deployment system.

## Cloning -- original sources

To clone the project, type

```
git clone git@gitlab.esrf.fr:accelerators/Magnets/MagnetType.git
```

## Documentation

Pogo generated doc on commands, attributes,... in **doc_html** folder

## Building and Installation

### Dependencies

The project has the following dependencies.

#### Project Dependencies

* Tango Controls 9 or higher.
* omniORB release 4 or higher.
* libzmq - libzmq3-dev or libzmq5-dev.

#### Toolchain Dependencies **(Delete If Does Not Apply)**

* C++11 compliant compiler.

### Build

Instructions on building the project.

Make example:

```bash
cd MagnetType
mkdir -p build/<os>
cd build/<os>
cmake ../..
make
```
